/*
 * Serial messages (6)
 * Découper une chaine de caractères contenant des espaces (" ")
 * Tiré de https://www.inkling.com/read/arduino-cookbook-michael-margolis-2nd/chapter-2/recipe-2-7
 */

// chaine de caractères pour contenir les données brutes
String inputString = "";

// pour savoir si la chaine est complète
boolean stringComplete = false;  

int cnt = 0; // nombre de données découpées
String data[10]; // stockage des données découpées

void setup() {
  Serial.begin(9600); // port série
}

void loop() {
  // si le message est complet
  if (stringComplete) {
    
    // on le découpe à chaque espace ' '
    // et on stocke les bouts dans un tableau
    splitString(inputString, ' ');
    
    // appel des fonctions selon le premier sélecteur
    if (data[0] == "LED") {
      light(data[1].toInt(), data[2].toInt()); 
    }
    else if (data[0] == "MODE") {
      mode(data[1].toInt(), data[2].toInt()); 
    }
    
    // vide la chaine
    inputString = "";           
    stringComplete = false;
  }
}

// serialEvent()
void serialEvent() {
  while (Serial.available()) {
    // récupérer le prochain octet (byte ou char) et l'enlever
    char inChar = (char)Serial.read(); 
    // concaténation des octets reçus
    inputString += inChar;
    // caractère de fin pour notre chaine
    if (inChar == '\n') {  
      stringComplete = true;
    }
  }
}

// méthode pour découper le message avec un séparateur (ou "parser")
void splitString(String message, char separator) {
  int index = 0;
  cnt = 0;
    do {
      index = message.indexOf(separator); 
      // s'il y a bien un caractère séparateur
      if(index != -1) { 
          // on découpe la chaine et on stocke le bout dans le tableau
          data[cnt] = message.substring(0,index); 
          cnt++;
          // on enlève du message le bout stocké
          message = message.substring(index+1, message.length());
      } else {
         // après le dernier espace   
         // on s'assure que la chaine n'est pas vide
         if(message.length() > 0) { 
           data[cnt] = message.substring(0,index); // dernier bout
           cnt++;
         }
      }
   } while(index >=0); // tant qu'il y a bien un séparateur dans la chaine
}

// fonction personnalisable
void light(int pin, int brightness) {
  Serial.print("Light function : ");
  Serial.print(pin);
  Serial.print(", ");
  Serial.println(brightness);
  //analogWrite(pin,brightness);
}

// fonction personnalisable
void mode(int pin, int state) {
  Serial.print("Mode function : ");
  Serial.print(pin);
  Serial.print(", ");
  Serial.println(state);
  //pinMode(pin,state);
}
